program FlashPascal;

{ Pascal for Flash compiler (c)2008 by Paul TOTH <tothpaul@free.fr> }

{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

{ 2008-06-14
   version 0.1 - Proof of concept !

  2008-06-17
   version 0.2 - this is a fun project :D

   SWFOptimize to concat PUSH operations
   SWFDictionary to define a string pool
   FOR loop support
   ARRAY support
   some changes in class construction

}

// http://www.m2osw.com/fr/swf_alexref.html

{$APPTYPE CONSOLE}

{%file 'Hello.pas'}
{%file 'Calc.pas'}

{$DEFINE SHELL}
{-$DEFINE LOG}

{$IFDEF SHELL}
uses
  Windows,
  ShellAPI,
  SysUtils;

{$ENDIF}

//----------------------------------------------------------------------------//
// the SWF code part is based on Sphing (Swf with PHp without mING)
// Project homepage: http://sphing.sourceforge.net/
// Copyright 2002 Igor Clukas <igor -at- clukas -dot- de>

const
 acEndAction      =#$00;
 acSubstract      =#$0B;
 acMultiply       =#$0C;
 acDivide         =#$0D;
 acLogicalNot     =#$12;
 acPop            =#$17;
 acIntegralPart   =#$18;
 acGetVariable    =#$1C;
 acSetVariable    =#$1D;
 acConcat         =#$21;
 acSubString      =#$35;
 acSetLocalVar    =#$3C;
 acCallFunction   =#$3D;
 acReturn         =#$3E;
 acModulo         =#$3F;
 acDeclareLocalVar=#$41;
 acAdd            =#$47;
 acLessThan       =#$48;
 acEqual          =#$49;
 acDuplicate      =#$4C;
 acGetMember      =#$4E;
 acSetMember      =#$4F;
 acIncrement      =#$50;
 acDecrement      =#$51;
 acDeclareFunction=#$9B;

function SWFshort(value:word):string;
begin
 SetLength(Result,SizeOf(Value));
 move(value,Result[1],SizeOf(value));
end;

type
 TDictionary=class
  Value:string;
  Next :TDictionary;
 end;

 TDicInfo=record
  Items :TDictionary;
  Length:integer;
  Count :integer;
 end;

var
 Dictionary:TDicInfo;

function DictionaryIndex(const Str:string):integer;
var
 d:TDictionary;
 l:TDictionary;
begin
 Result:=0;
 l:=nil;
 d:=Dictionary.Items;
 while d<>nil do begin
  if d.Value=Str then exit;
  l:=d;
  d:=d.Next;
  inc(Result);
 end;
 if (Result>255)or((Length(Str)+Dictionary.Length+2)>65535) then
  Result:=-1
 else begin
  d:=TDictionary.Create;
  d.value:=Str;
  if l=nil then Dictionary.Items:=d else l.Next:=d;
  inc(Dictionary.Length,Length(Str)+1);
  inc(Dictionary.Count);
 end;
end;

function SWFDictionary:string;
var
 n:TDictionary;
begin
 if Dictionary.Items=nil then
  Result:=''
 else begin
  Result:=#$88+SWFshort(Dictionary.Length+2)+SWFshort(Dictionary.Count);
  while Dictionary.Items<>nil do begin
   n:=Dictionary.Items.Next;
   Result:=Result+Dictionary.Items.Value+#0;
   Dictionary.Items.Free;
   Dictionary.Items:=n;
  end;
 end;
end;

function SWFlong(value:integer):string;
begin
 SetLength(Result,SizeOf(Value));
 move(value,Result[1],SizeOf(value));
end;

function SWFPushBoolean(Value:boolean):string;
begin
 Result:=#$96+SWFshort(2)+#$05+chr(ord(Value));
end;

function SWFPushInteger(Value:integer):string;
begin
 Result:=#$96+SWFshort(5)+#$07+SWFlong(value);
end;

function SWFPushString(const Str:string):string;
var
 i:integer;
begin
 i:=DictionaryIndex(Str);
 if i<0 then
  Result:=#$96+SWFshort(Length(Str)+2)+#0+Str+#0
 else
  Result:=#$96+#$02#$00#$08+chr(i);
end;

function SWFGetVariable(const name:string):string;
begin
 Result:=SWFPushString(name)+acGetVariable;
end;

function SWFGetMember(const name:string):string;
begin
 Result:=SWFPushString(name)+acGetMember;
end;

function SWFCallMethod(const name:string):string;
begin
 Result:=SWFPushString(name)+#$52;
end;

function SWFNewObject(const name:string):string;
begin
 Result:=SWFPushString(name)+#$40;
end;

function SWFSetMember(const name:string):string;
begin
 Result:=SWFPushString(name)+#$4F;
end;

function SWFlhead(id, length:cardinal):string;
begin
 Result:=SWFshort((id shl 6) or $3f)+SWFlong(length);
end;

function SWFshead(id,length:cardinal):string;
begin
 Result:=SWFshort((id shl 6) or (length and $3f));
end;

function SWFDoAction(Actions:string):string;
begin
 Actions:=SWFDictionary+Actions;
 Result:=SWFlhead(12,Length(Actions))+Actions;
end;

function SWFAttributes(Flags:cardinal):string;
begin
 Result:=SWFshead(69,4)+SWFlong(Flags);
end;

function SWFBackground(r,g,b:byte):string;
begin
 Result:=SWFshead(9, 3) + chr(r) + chr(g) + chr(b);
end;

function SWFEndTag:string;
begin
 Result:=SWFshead(0,0);
end;

function SWFbin(const bin:string):string;
var
 i,v,b:integer;
begin
 Result:='';
 v:=0;
 b:=0;
 for i:=1 to length(bin) do begin
  v:=v shl 1;
  if bin[i]='1' then inc(v);
  inc(b);
  if b=8 then begin
   Result:=Result+chr(v);
   v:=0;
   b:=0;
  end;
 end;
 if b>0 then Result:=Result+chr(v shl (8-b));
end;


function SWFval2bin(v, bits:integer):string;
var
 i:integer;
begin
 SetLength(Result,bits);
 for i:=bits downto 1 do begin
  if odd(v) then Result[i]:='1' else Result[i]:='0';
  v:=v shr 1;
 end;
end;

function SWFval2bin2(v, bits:cardinal):string;
var
 i:integer;
begin
 SetLength(Result,bits);
 for i:=bits downto 1 do begin
  if odd(v) then Result[i]:='1' else Result[i]:='0';
  v:=v shr 1;
 end;
 while v>0 do begin
  if odd(v) then Result:='1'+Result else Result:='0'+Result;
  v:=v shr 1;
 end;
end;
function SWFrect(x1, y1, x2, y2:integer):string;
var
 bits:integer;
begin
 if (abs(x1)<$1fff)and(abs(y1)<$1fff)and(abs(x2)<$1fff)and(abs(y2)<$1fff) then bits:=14 else bits:=16;
 Result:=SWFbin(SWFval2bin2(bits,5)
               +SWFval2bin(x1,bits)
               +SWFval2bin(x2,bits)
               +SWFval2bin(y1,bits)
               +SWFval2bin(y2,bits));
end;

function SWFShowframe():string;
begin
 Result:=SWFshead(1,0);
end;

function SWFHeader(ver, fsize, w, h, rate, frames:cardinal):string;
begin
 Result:=SWFrect(0,0,w*20,h*20)+#0+chr(rate)+SWFshort(frames);
 inc(fsize , length(result) + 8);
 Result:='FWS' + chr(ver) + SWFlong(fsize) + Result;
end;

function Branch(ofs:smallint):string;
begin
 Result:=#$99#$02#$00+SWFshort(word(ofs));
end;

function BranchIfEq(ofs:smallint):string;
begin
 Result:=#$9D#$02#$00+SWFshort(word(ofs));
end;

function SWFCallFunction(const Name:string):string;
begin
 Result:=SWFPushString(Name)
        +acCallFunction;
end;

// concat Push operations
function SWFOptimize(code:string):string;
var
 i:integer;
 l:integer;
 c:byte;
 w:word;
 n:integer;
begin
 i:=1;
 while i<length(code) do begin
  c:=ord(code[i]);
  inc(i);
  if (c and $80)=0 then
   l:=0
  else begin
   move(code[i],w,2);
   inc(i,2);
   l:=w;
  end;
  if (c=$96)and(code[i+l]=#$96) then begin // 2 PUSH
   move(code[i+l+1],w,2);
   if l+w<65535 then begin // we can merge them
    code:=copy(code,1,i-3)+SWFshort(l+w)+copy(code,i,l)+copy(code,i+l+3,MaxInt);
    i:=i-3;
    l:=0;
   end;
  end;
  inc(i,l);
 end;
 Result:=code;
end;

//----------------------------------------------------------------------------//

type
 TToken=(

 // Pascal keywords
  tkProgram,
  tkVar, tkType, tkConst,
  tkBegin, tkEnd,
  tkProcedure,
  tkExternal,
  tkClass, tkConstructor, tkAs,
  tkProperty,
  tkNil,
  tkDiv, tkMod,
  tkTrue,tkFalse,
  tkFor, tkTo, tkDownto, tkDo,
  tkArray, tkOf,
  tkObject,
  tkInherited,
  tkSelf,
  tkCopy,
  tkCase, tkElse,

 // built in functions
  tkIntToStr,

 // user defined symbol
  tk_Symbol, tk_Variable, tk_Parameter, tk_Property, tk_Method, tk_Prototype, tk_Class,

 // Symbols, etc...
  tk_Equal,
  tk_Add, tk_Sub, tk_Mul, tk_Slash, tk_Range,
  tk_Assign, tk_Comma, tk_Colon, tk_SemiColon, tk_Dot,
  tk_LParen, tk_RParen,
  tk_LBracket, tk_RBracket,
  tk_String, tk_Number, tk_Float, tk_Ident,
  tk_LComment1, tk_RComment1, tk_Comment2,
  tk_Switch1

 );

//----------------------------------------------------------------------------//
var
 Source   :TextFile; // source file
 Line     :integer;  // current line
 Index    :integer;  // current char in line
 Src      :string;   // current readed line
 SrcToken :string;   // current token
 LastChar :char;     // last readed char
 NextChar :char;     // current readed char (next in token)
 Token    :string;   // current token (uppercase for keywords, without quotes for litteral strings)
 TokenType:TToken;   // what kind of token is it ?

 FrameWidth :word; // SWF frame properties
 FrameHeight:word;
 FrameRate  :byte;
 Background :cardinal; // Frame background

//----------------------------------------------------------------------------//
type
 TSymbol=class
  name      :string;  // upper case name
  realName  :string;  // the real name as in type or var definition
  NextSymbol:TSymbol; // linked list of symbols
 end;

 TVariable=class(TSymbol)
  Kind    :TSymbol;
  Owner   :TSymbol; // nil for Global var...
 end;

 TParameter=class(TSymbol)
  IsConst:boolean;   // not used for now
  ByRef  :boolean;
  Kind   :TSymbol;
  NextParam:TParameter;
 end;

 TFunction=class(TSymbol)
  count   :integer;
  params  :TParameter;
  Kind    :TSymbol;   // function result
 end;

 TMethod=class(TFunction)
  alias   :string;    // alias used for MovieClip.createTextField()
  Parent  :TParameter;    // MovieClip is this case
  code    :string;    // for UserClass only
  Owner   :TSymbol;
  Symbols :TSymbol;
 end;

 TPrototype=class(TFunction)
  OfObject:boolean;   // function prototype only
 end;

 TProperty=class(TSymbol)
  Kind : TSymbol;
  Alias: string;
 end;

 TClass=class(TSymbol)
  _inherite   : TClass;
  _constructor: TMethod;
  _symbols    : TSymbol;
 end;

 TUserClass=class(TClass)
  init      : string;
 end;

 TArray=class(TSymbol)
  _low  : integer;
  _high : integer;
  _kind : TSymbol;
 end;

 TExpression=class
  code:string;
  kind:TSymbol;
  procedure Add(ex:TExpression);
  procedure Sub(ex:TExpression);
  procedure Negate;
  procedure VarSuffix;
 end;

 TInstance=record
  code  : string;
  kind  : TSymbol;
  getter: string;
  setter: string;
 end;

 PScope=^TScope;
 TScope=record
  Symbol:TSymbol;
  Next  :PScope;
 end;

var
 Symbols   :TSymbol; // chained list of symbols
 SymName   :string;  // parsed symbol name
 Symbol    :TSymbol; // token symbol
 Variable  :TVariable absolute Symbol;
 Parameter :TParameter absolute Symbol;

 Scopes    :PScope;

 _Root     :TVariable; // hidden symbol
 _String   :TSymbol;   // Flash String
 _Integer  :TSymbol;   // base type integer
 _Boolean  :TSymbol;   // base type boolean
 _Object   :TSymbol;

//----------------------------------------------------------------------------//
procedure Error(const Msg:string);
var
 i:integer;
begin
 WriteLn('Error on line ',line,' at char ',index,' on ',SrcToken);
 WriteLn(Src);
 for i:=1 to Index-Length(SrcToken)-1 do Write(' ');
 for i:=1 to Length(SrcToken) do Write('^');
 WriteLn;
 WriteLn(Msg);
 ReadLn;
 Halt;
end;

function IntToStr(i:integer):string;
begin
 Str(i,Result);
end;

// convert Str to an integer
function StrToInt(const Str:string):integer;
var
 e:integer;
begin
 Val(Str,Result,e);
 if e>0 then Error('Invalid number '+str);
end;

// compare two litteral integers
function StrLess(const Str,Value:string):boolean;
var
 i,l:integer;
begin
 l:=Length(Str);
 if l=Length(Value) then begin
  for i:=1 to l do begin
   if Str[i]>Value[i] then begin
    Result:=False;
    exit;
   end;
  end;
  Result:=True;
 end else begin
  Result:=l<Length(Value);
 end;
end;

// how many bits to store this numeric ?
function BitsCount(const Str:string):integer;
begin
 case Length(Str) of
  0    : Error('Invalid number');
  1..2 : Result:=8;
  3    : if StrLess(Str,'255') then Result:=8 else Result:=16;
  4    : Result:=16;
  5    : if StrLess(Str,'65535') then Result:=16 else Result:=32;
  else   if StrLess(Str,'4294967295') then Result:=32 else Error('cardinal overflow');
 end;
end;

// read one char
function ReadChar:char;
begin
 SrcToken:=SrcToken+NextChar;
 LastChar:=NextChar;
 Result:=NextChar;
 if Eof(Source) then Error('Unexpected end of file');
 Read(Source,NextChar);
{$IFDEF LOG}Write(NextChar);{$ENDIF} 
 if NextChar=#13 then inc(Line) else
 if NextChar=#10 then Index:=0 else begin
  inc(Index);
  if Index=1 then Src:=NextChar else Src:=Src+NextChar;
 end;
end;

// skip one char ?
function SkipChar(c:char):boolean;
begin
 Result:=NextChar=c;
 if Result then ReadChar;
end;

function CheckSymbol(List:TSymbol):boolean;
begin
 Symbol:=List;
 while Symbol<>nil do begin
  if Symbol.name=Token then begin
   if Symbol is TVariable then
    TokenType:=tk_Variable
   else
   if Symbol is TParameter then
    TokenType:=tk_Parameter
   else
   if Symbol is TProperty then
    TokenType:=tk_Property
   else
   if Symbol is TClass then
    TokenType:=tk_Class
   else
   if Symbol is TMethod then
    TokenType:=tk_Method
   else
    TokenType:=tk_Symbol;
   Result:=True;
   exit;
  end;
  Symbol:=Symbol.NextSymbol;
 end;
 Result:=False;
end;

function CheckScope(Symbol:TSymbol):boolean;
var
 cl:TClass;
begin
 Result:=False;
 if Symbol is TClass then begin
  cl:=TClass(Symbol);
  while cl<>nil do begin
   Result:=CheckSymbol(cl._symbols);
   if Result then exit;
   cl:=cl._inherite;
  end;
 end else
 if Symbol is TMethod then begin
  Result:=CheckSymbol(TMethod(Symbol).Symbols);
 end else
  Error('CheckScope for '+Symbol.ClassName);
end;

// read an alpha token
procedure AlphaToken;
var
 scope:PScope;
begin
 TokenType:=tk_Ident;
 while upcase(NextChar) in ['_','A'..'Z','0'..'9'] do begin
  Token:=Token+upcase(ReadChar);
 end;
// check for reserved keyword
 if Token='PROGRAM'     then TokenType:=tkProgram else
 if Token='VAR'         then TokenType:=tkVar else
 if Token='TYPE'        then TokenType:=tkType else
 if Token='CONST'       then TokenType:=tkConst else
 if Token='BEGIN'       then TokenType:=tkBegin else
 if Token='END'         then TokenType:=tkEnd else
 if Token='PROCEDURE'   then TokenType:=tkProcedure else
 if Token='NIL'         then TokenType:=tkNil else
 if Token='DIV'         then TokenType:=tkDiv else
 if Token='MOD'         then TokenType:=tkMod else
 if Token='TRUE'        then TokenType:=tkTrue else
 if Token='FALSE'       then TokenType:=tkFalse else
 if Token='FOR'         then TokenType:=tkFor else
 if Token='TO'          then TokenType:=tkTo else
 if Token='DOWNTO'      then TokenType:=tkDownto else
 if Token='DO'          then TokenType:=tkDo else
 if Token='ARRAY'       then TokenType:=tkArray else
 if Token='OF'          then TokenType:=tkOf else
 if Token='OBJECT'      then TokenType:=tkObject else
 if Token='INHERITED'   then TokenType:=tkInherited else
 if Token='SELF'        then TokenType:=tkSelf else
 if Token='COPY'        then TokenType:=tkCopy else
 if Token='CASE'        then TokenType:=tkCase else
 if Token='ELSE'        then TokenType:=tkElse else
 if Token='INTTOSTR'    then Tokentype:=tkIntToStr else
 if Token='EXTERNAL'    then TokenType:=tkExternal else
 if Token='CLASS'       then TokenType:=tkClass else
 if Token='CONSTRUCTOR' then TokenType:=tkConstructor else
 if Token='AS'          then TokenType:=tkAs else
 if Token='PROPERTY'    then TokenType:=tkProperty else
 begin
 // Check for local scope symbols
  scope:=Scopes;
  while scope<>nil do begin
   if CheckScope(scope.Symbol) then exit;
   scope:=scope.Next;
  end;
 // global scope also
  CheckSymbol(Symbols);
 end;
end;

// read a numeric token
procedure NumericToken;
begin
 TokenType:=tk_Number;
 while NextChar in ['0'..'9'] do begin
  Token:=Token+ReadChar;
 end;
(* !!! WARNING 0..1 is not a Float !
 if NextChar='.' then begin
  TokenType:=tk_Float;
  Token:=Token+ReadChar;
  while NextChar in ['0'..'9'] do begin
   Token:=Token+ReadChar;
  end;
 end;
*)
end;

// read a quoted string
function StringConst:string;
var
 done:boolean;
begin
 ReadChar; // ''''
 Result:='';
 repeat
  while NextChar<>'''' do begin
   if NextChar=#13 then Error('Open string');
   Result:=Result+ReadChar;
  end;
  ReadChar; // ''''
  if NextChar='''' then begin
   Result:=Result+ReadChar;
   done:=False;
  end else begin
   done:=True;
  end;
 until done;
end;

// read an ascii char value (#xxx)
function AsciiChar:string;
begin
 ReadChar; // #
 Result:='';
 while NextChar in ['0'..'9'] do Result:=Result+ReadChar;
 if BitsCount(Result)>8 then Error('byte overflow');
 Result:=chr(StrToInt(Result));
end;

// read a string made of litterals ans ascii chars
procedure StringToken;
begin
 TokenType:=tk_String;
 while NextChar in ['#',''''] do begin
  if NextChar='#' then
   Token:=Token+AsciiChar
  else
   Token:=Token+StringConst;
 end;
end;

// get a special symbol
procedure SymbolToken;
begin
 case ReadChar of
  '=' : TokenType:=tk_Equal;
  '+' : TokenType:=tk_Add;
  '-' : TokenType:=tk_Sub;
  '*' : TokenType:=tk_Mul;
  '.' : if SkipChar('.') then TokenType:=tk_Range else TokenType:=tk_Dot;
  ',' : TokenType:=tk_Comma;
  ':' : if SkipChar('=') then TokenType:=tk_Assign else TokenType:=tk_Colon;
  ';' : TokenType:=tk_SemiColon;
  '(' : TokenType:=tk_LParen;
  ')' : TokenType:=tk_RParen;
  '{' : if SkipChar('$') then TokenType:=tk_Switch1 else TokenType:=tk_LComment1;
  '}' : TokenType:=tk_RComment1;
  '[' : TokenType:=tk_LBracket;
  ']' : TokenType:=tk_RBracket;
  '/' : if SkipChar('/') then Tokentype:=tk_Comment2 else TokenType:=tk_Slash;
  else  Error('Unknow symbol '+LastChar);
 end;
end;

// get an hexadecimal number
procedure HexaToken;
begin
 TokenType:=tk_Number;
 Token:=ReadChar;
 while upcase(NextChar) in ['0'..'9','A'..'F'] do begin
  Token:=Token+upcase(ReadChar);
 end;
 if Length(Token)>9 then Error('Ordinal overflow');
end;

// get the next token
procedure GetToken;
begin
 while NextChar<=#32 do ReadChar;
 SrcToken:='';
 Token:='';
 case upcase(NextChar) of
  '_','A'..'Z' : AlphaToken;
  '0'..'9'     : NumericToken;
  '$'          : HexaToken;
  '#',''''     : StringToken;
  else           SymbolToken;
 end;
end;

// requiered token
procedure DropToken(Token:TToken); forward;

// deal with Frame properties
procedure CompilerSwitch(StopToken:TToken);
var
 s:string;
 switch:(sFrameWidth,sFrameHeight,sFrameRate,sBackground);
 b:integer;
begin
 s:='';
 while upcase(NextChar) in ['A'..'Z','_'] do s:=s+upcase(ReadChar);
 if s='FRAME_WIDTH'  then switch:=sFrameWidth  else
 if s='FRAME_HEIGHT' then switch:=sFrameHeight else
 if s='FRAME_RATE'   then switch:=sFrameRate   else
 if s='BACKGROUND'   then switch:=sBackground  else error('Unknow switch '+s);
 GetToken;
 if TokenType<>tk_Number then Error('Integer expected');
 b:=BitsCount(Token);
 if switch=sBackground then begin
  if b>32  then Error('Ordinal overflow');
 end else
 if switch=sFrameRate then begin
  if b>8  then Error('Byte overflow');
 end else begin
  if b>16 then Error('Word overflow');
 end;
 case switch of
  sFrameWidth  : FrameWidth :=StrToInt(Token);
  sFrameHeight : FrameHeight:=StrToInt(Token);
  sFrameRate   : FrameRate  :=StrToInt(Token);
  sBackground  : Background :=StrToInt(Token);
 end;
 GetToken;
 DropToken(StopToken);
end;

// get the next token, handle compiler switch & comments
procedure NextToken;
begin
 GetToken;
 case TokenType of
  tk_LComment1 : begin
   repeat until ReadChar='}';
   NextToken;
  end;
  tk_Comment2 : begin
   repeat until ReadChar in [#10,#13];
   NextToken;
  end;
  tk_Switch1   : CompilerSwitch(tk_RComment1);
 end;
end;

// skip a token
function SkipToken(Token:TToken):boolean;
begin
 Result:=TokenType=Token;
 if Result then NextToken;
end;

// request a token
procedure DropToken(Token:TToken);
begin
 if not Skiptoken(Token) then
  Error('Unexpected token (drop)');
end;

procedure DropIdent(const Ident:string);
begin
 if Token<>Ident then Error('Expected '+Ident);
 NextToken;
end;

// request an ident
function GetIdent:string;
begin
 if TokenType<>tk_Ident then Error('Ident expected');
 Result:=Token;
 NextToken;
end;

function GetInteger:integer;
begin
 if TokenType<>tk_Number then Error('number expected');
 if BitsCount(Token)>32 then Error('ordinal overflow');
 Result:=StrToInt(Token);
 NextToken;
end;

function ClassSymbol(AClass:TClass):TSymbol; forward;

//----------------------------------------------------------------------------//
// ... not used for now, but it's probably a better way to deal with expressions
procedure TExpression.Add(ex:TExpression);
begin
 if Kind=_String then begin
  if (ex.Kind=_String) then begin
   code:=code+ex.Code+acConcat;
   ex.Free;
  end else begin
   Error('string concat error');
  end;
 end else
 if Kind=_Integer then begin
  if ex.Kind=_Integer then begin
   code:=code+ex.Code+acAdd;
   ex.Free;
  end else
   Error('integer add error');
 end else
  Error('Add error');
end;

procedure TExpression.Sub(ex:TExpression);
begin
 if Kind=_Integer then begin
  if ex.Kind=_Integer then begin
   code:=code+ex.Code+acSubstract;
   ex.Free;
  end else
   error('Integer sub error');
 end else
  Error('Sub error');
end;

procedure TExpression.Negate;
var
 i:integer;
begin
 // have we push a constant integer ?
 if (Length(Code)=8)and(copy(code,1,4)=#$96#$05#$00#$07) then begin
  move(code[5],i,4);
  i:=-i;
  move(i,code[5],4);
 end else begin
  code:=SWFPushInteger(0)+code+acSubstract;
 end;
end;

procedure TExpression.VarSuffix;
var
 s:TSymbol;
begin
 while SkipToken(tk_Dot) do begin
  if not (Kind is TClass) then Error('Class expected');
  s:=ClassSymbol(Kind as TClass);
  if s is TVariable then begin
   code:=code+SWFPushString(s.realName)+acGetMember;
   kind:=TVariable(s).Kind;
  end else
  if s is TProperty then begin
   code:=code+SWFPushString(s.realName)+acGetMember;
   kind:=TProperty(s).Kind;
  end else
   Error(s.className);
 end;
end;

function Expression:TExpression; forward;
function GetVariable(Variable:TVariable):string; forward;

function Expression1:TExpression;
var
 e:TExpression;
begin
 if TokenType=tk_String then begin
  Result:=TExpression.Create;
  Result.code:=SWFPushString(Token);
  Result.kind:=_String;
  NextToken;
 end else
 if TokenType=tkIntToStr then begin
  NextToken;
  DropToken(tk_LParen);    
  Result:=Expression;
  if Result.Kind<>_Integer then Error('ordinal expected');
  DropToken(tk_RParen);
  Result.Kind:=_String; // nothing else to do ? or add acString(#$4B)
 end else
 if TokenType=tkCopy then begin
  NextToken;
  DropToken(tk_LParen);
  Result:=Expression;
  if Result.Kind<>_String then Error('String expected');
  DropToken(tk_Comma);
  e:=Expression;
  if e.kind<>_Integer then Error('integer expected');
  Result.code:=Result.code+e.code;
  e.Free;
  DropToken(tk_Comma);
  e:=Expression;
  if e.kind<>_Integer then Error('integer expected');
  Result.code:=Result.code+e.code;
  e.Free;
  DropToken(tk_RParen);
  Result.code:=Result.code+acSubString;
 end else
 if TokenType=tk_Variable then begin
  Result:=TExpression.Create;
  Result.Code:=GetVariable(Variable);
  Result.Kind:=Variable.Kind;
  NextToken;
  Result.VarSuffix;
 end else
 if TokenType=tk_Sub then begin
  NextToken;
  Result:=Expression;
  if Result.Kind<>_Integer then Error('ordinal expected');
  Result.Negate;
 end else
 if TokenType=tk_Number then begin
  if BitsCount(Token)>32 then Error('Integer overflow');
  Result:=TExpression.Create;
  Result.Code:=SWFPushInteger(StrToInt(Token));
  Result.kind:=_Integer;
  NextToken;
 end else
  Error('Expression1');
end;

function Expression:TExpression;
var
 op:TToken;
 ex:TExpression;
begin
 Result:=Expression1;
 while TokenType in [tk_Add, tk_Sub] do begin
  op:=TokenType;
  if (op=tk_Sub)and(Result.Kind<>_Integer) then Error('Ordinal expected');
  NextToken;
  ex:=Expression1;
  if op=tk_Add then Result.Add(ex) else Result.Sub(ex);
 end;
end;

//----------------------------------------------------------------------------//
function GetType:TSymbol; forward;

function GetArray:TArray;
begin
 NextToken;
 DropToken(tk_LBracket);

 Result:=TArray.Create;
 Result._low:=GetInteger;
 DropToken(tk_Range);
 Result._high:=GetInteger;

 DropToken(tk_RBracket);
 DropToken(tkOf);

 Result._kind:=GetType;
end;

// NB: Flash do not use typed variable, but we are Pascal programmers :D
function GetType:TSymbol;
begin
 if TokenType=tk_Class then begin
  Result:=Symbol;
  NextToken;
 end else
 if TokenType=tk_Symbol then begin
  if (Symbol=_String) or (Symbol=_Integer) or (Symbol=_Boolean) or (Symbol=_Object) or (Symbol is TFunction) then begin
   Result:=Symbol;
   NextToken;
  end else begin
   Error('type expected 1');
  end;
 end else
 if TokenType=tkArray then
  Result:=GetArray
 else begin
  Error('type expected 2 ');
 end;
end;

function GetClass:TClass;
var
 s:TSymbol;
begin
 s:=GetType;
 if not (s is TClass) then Error('Class expected');
 Result:=TClass(s);
end;

// var declaration
function DeclareVar(Owner:TSymbol; var Symbols:TSymbol):string;
var
 v:TVariable;
begin
 Result:='';
 v:=TVariable.Create;
 v.Owner:=Owner;
 v.realName:=SrcToken;
 v.name:=GetIdent;
 v.NextSymbol:=Symbols;
 Symbols:=v;
 if SkipToken(tk_Comma) then begin
  Result:=DeclareVar(Owner,Symbols);
  v.Kind:=TVariable(Symbols).Kind;
 end else begin
  Result:='';
  DropToken(tk_Colon);
  v.Kind:=GetType;
 end;

 if v.Kind is TArray then begin
  Result:=Result
         +SWFOptimize(
           SWFPushString(v.realName)
          +SWFPushInteger(0)
          +SWFNewObject('Array')
          +acSetVariable
          );
 end else
 if v.Owner is TMethod then begin
  Result:=Result+SWFPushString(v.realName)+acDeclareLocalVar;
 end;
end;

// one method parameter
function GetParam(Func:TFunction; Prev:TParameter):TParameter;
var
 p:TParameter;
begin
 Result:=TParameter.Create;
// param1,param2 : type
 if Prev=nil then begin
  if SkipToken(tkConst) then Result.IsConst:=True else
  if SkipToken(tkVar)   then Result.ByRef:=True;
 end else begin
  Result.IsConst:=Prev.IsConst;
  Result.ByRef:=Prev.ByRef;
 end;
// param name
 Result.realName:=SrcToken;
 Result.name:=GetIdent;
// check for duplicates
 p:=Func.params;
 while p<>nil do begin
  if p.name=Result.name then Error('Duplicate param name');
  p:=p.NextParam;
 end;
// add the parameter to the method
 Result.NextParam:=Func.params;
 Result.NextSymbol:=Func.params; // prepare linked list
 Func.params:=Result;
 inc(Func.count);
// one more ?
 if SkipToken(tk_Comma) then begin
  p:=GetParam(Func,Result);
  Result.Kind:=p.Kind;
 end else begin
// get type
  DropToken(tk_Colon);
  Result.Kind:=GetType;
 end;
end;

// return last parameter of a method
function LastParm(Method:TMethod):TParameter;
begin
 Result:=Method.params;
 if Result<>nil then begin
  while Result.NextParam<>nil do Result:=Result.NextParam;
 end;
end;

function LastSymbol(Symbols:TSymbol):TSymbol;
begin
 Result:=Symbols;
 if Result<>nil then begin
  While Result.NextSymbol<>nil do Result:=Result.NextSymbol;
 end;
end;

// read a class method
function GetMethod(AClass:TClass; void:boolean):TMethod;
var
 m:TMethod;
 p:TParameter;
begin
 m:=TMethod.Create;
 m.Owner:=AClass;
 m.realName:=SrcToken;
 m.name:=GetIdent;
 if SkipToken(tk_LParen) then begin
  while not SkipToken(tk_RParen) do begin
   p:=GetParam(m,nil);
   if TokenType<>tk_RParen then DropToken(tk_SemiColon);
  end;
 end;
 if not void then begin
 // function method
  DropToken(tk_Colon);
  m.Kind:=GetType;
 end;
 m.NextSymbol:=AClass._symbols;
 AClass._symbols:=m;
 Result:=m;
end;

// we use a special syntax to define a pseudo constructor for "MovieClip.createTextField(instanceName,...)"
// constructor Create(Parent:MovieClip,...) as Parent.createTextField
procedure ConstructorAlias(m:TMethod);
var
 p:TParameter;
begin
// Last parm is the first one (reversed chained list)
 p:=LastParm(m);
// we need one
 if (p=nil) then Error('method alias need at least one parameter');
// need to be a class
 if (p.Kind=nil)or(not(p.Kind is TClass)) then Error('method alias need a parent class parameter');
// skip it name
 if GetIdent<>p.name then Error(p.name+' expected');
// dot
 DropToken(tk_Dot);
// get alias
 m.alias:=SrcToken;
 GetIdent;
// save the parent
 m.Parent:=p;
// remove it from param list
 if m.params=p then
  m.params:=nil
 else begin
  p:=m.params;
  while p.NextParam<>m.Parent do p:=p.NextParam;
  p.NextParam:=nil;
 end;
end;

// read class property
procedure GetProperty(AClass:TClass);
var
 p:TProperty;
begin
 p:=TProperty.Create;
 p.realName:=SrcToken;
 p.name:=GetIdent;
 p.NextSymbol:=AClass._symbols;
 AClass._symbols:=p;
 DropToken(tk_Colon);
 p.Kind:=GetType;
end;

// define an external class : a Flash class
procedure ExternalFlashClass(const ClassName, SymbolName:string);
var
 ss:TSymbol;
 cl:TClass;
begin
 DropToken(tkClass);
 cl:=TClass.Create;
// we nee a case sensitive name !
 cl.realName:=ClassName;
 cl.name:=SymbolName;
 cl.NextSymbol:=Symbols;
 Symbols:=cl;
 ss:=Symbols;
 while not SkipToken(tkEnd) do begin
 // todo: support multiple constructor ?
  if SkipToken(tkConstructor) then begin
   if cl._constructor<>nil then Error('duplicate constructor');
   cl._constructor:=GetMethod(cl,true);
   cl._constructor.Kind:=cl;
   if SkipToken(tkAs) then ConstructorAlias(cl._constructor);
  end else
 // todo: support for function :)
  if SkipToken(tkProcedure) then begin
   GetMethod(cl,true);
  end else
 // todo: readonly, writeonly attributes
  if SkipToken(tkProperty) then begin
   GetProperty(cl);
  end else
   Error('unexpected');
  if TokenType<>tkEnd then DropToken(tk_SemiColon);
 end;
end;

procedure DefineUserClass(const name,symbol:string);
var
 c:TUserClass;
 m:TMethod;
begin
 c:=TUserClass.Create;
 c.realName:=name;
 c.name:=symbol;
 c.NextSymbol:=Symbols;
 Symbols:=c;
 if SkipToken(tk_LParen) then begin
  c._inherite:=GetClass;
  DropToken(tk_RParen);
 end;
 while not SkipToken(tkEnd) do begin
  if TokenType=tk_Ident then begin
   c.init:=c.init+DeclareVar(c,c._symbols);
  end else
  if SkipToken(tkConstructor) then begin
   if c._constructor<>nil then Error('duplicate constructor');
   c._constructor:=GetMethod(c,true);
   c._constructor.Kind:=c;
   //Error('constructor');
  end else
  if SkipToken(tkProcedure) then begin
   m:=GetMethod(c,true);
   //m.realName:=c.realName+'$'+m.realName;
   c.init:=c.init+SWFGetVariable('this')
                 +SWFPushString(m.realName)
                 +SWFGetVariable(c.realName+'$'+m.realName)
                 +acSetMember;
  end else
   Error('what is this ?');
  if TokenType<>tkEnd then DropToken(tk_SemiColon);
 end;
// Error('user class');
end;

// declare a function prototype
procedure FunctionPrototype(const name:string; void:boolean);
var
 f:TPrototype;
 p:TParameter;
begin
 f:=TPrototype.Create;
 f.name:=name;
 f.NextSymbol:=Symbols;
 Symbols:=f;
 if SkipToken(tk_LParen) then begin
  while not SkipToken(tk_RParen) do begin
   p:=GetParam(f,nil);
   if TokenType<>tk_RParen then DropToken(tk_SemiColon);
  end;
 end;
 if SkipToken(tkOf) then begin
  DropToken(tkObject);
  f.OfObject:=True;
 end;
// -
end;

// declare a new type
procedure DeclareType;
var
 cname:string;
 uname:string;
begin
 cname:=SrcToken;
 uname:=GetIdent;
 DropToken(tk_Equal);
 if SkipToken(tkExternal) then begin
  ExternalFlashClass(cname,uname);
 end else
 if SkipToken(tkProcedure) then begin
  FunctionPrototype(uname,true);
 end else
 if SkipToken(tkClass) then begin
  DefineUserClass(cname,uname);
 end else
 // todo: user defined class, record ?
  Error('type expected (DeclareType)');
 DropToken(tk_SemiColon);
end;

//----------------------------------------------------------------------------//

// get a variable reference
function DropVariable:TVariable;
begin
 Result:=Variable;
 DropToken(tk_Variable);
end;

function PushString:string; forward;
function PushInteger:string; forward;

// push a string
// todo: multiple push optimization
function PushString1:string;
begin
 if TokenType=tk_String then begin
  Result:=SWFPushString(Token);
  NextToken;
 end else
 if TokenType=tkIntToStr then begin
  NextToken;
  DropToken(tk_LParen);
  Result:=PushInteger; // nothing to do ?!
  DropToken(tk_RParen);
 end else
 if TokenType=tkCopy then begin
  NextToken;
  DropToken(tk_LParen);
  Result:=PushString;
  DropToken(tk_Comma);
  Result:=Result+PushInteger;
  DropToken(tk_Comma);
  Result:=Result+PushInteger;
  DropToken(tk_RParen);
  Result:=Result+acSubString;
 end else
 if TokenType=tk_Variable then begin
  if Variable.Kind<>_String then Error('String type expected');
  Result:=SWFGetVariable(Variable.realName);
  NextToken;
 end else
  Error('PushString1');
end;

function PushString_old:string;
begin
 Result:=PushString1;
 while TokenType=tk_Add do begin
  NextToken;
  Result:=Result+PushString1+acConcat;
 end;
end;

function PushString:string;
var
 e:TExpression;
begin
 e:=Expression;
 if e.kind<>_String then Error('String expected');
 Result:=e.Code;
 e.Free;
end;

procedure VarInstance(variable:TVariable; var Instance:TInstance);
begin
 if variable.Owner=nil then begin
  instance.code  :=SWFPushString(variable.realName);
  instance.kind  :=variable.Kind;
  instance.getter:=acGetVariable;
  instance.setter:=acSetVariable;
 end else
 if variable.Owner is TClass then begin
  instance.code  :=SWFGetVariable('this')
                  +SWFPushString(variable.realName);
  instance.kind  :=variable.Kind;
  instance.getter:=acGetMember;
  instance.setter:=acSetMember;
 end else
 if variable.owner is TMethod then begin
  instance.code  :=SWFPushString(variable.realName);
  instance.kind  :=variable.Kind;
  instance.getter:=acGetVariable;
  instance.setter:=acSetLocalVar;
 end else
  Error('VarInstance for '+variable.Owner.ClassName);
 if SkipToken(tk_LBracket) then begin
  if not (instance.Kind is TArray) then Error('Array expected');
  instance.code:=instance.code
                +instance.getter
                +PushInteger;
  instance.getter:=acGetMember;
  instance.setter:=acSetMember;
  instance.kind:=TArray(instance.Kind)._kind;
  DropToken(tk_RBracket);
 end;
end;

function GetVariable(Variable:TVariable):string;
var
 Instance:TInstance;
begin
 VarInstance(Variable,Instance);
 Result:=Instance.code+Instance.getter;
end;

// push integer expression
function PushInteger2:string;
var
 val:integer;
begin
 if TokenType=tk_LParen then begin
  NextToken;
  Result:=PushInteger;
  DropToken(tk_RParen);
 end else
 if TokenType=tk_Number then begin
  if BitsCount(Token)>32 then Error('integer overflow');
  val:=StrToInt(Token);
  Result:=SWFPushInteger(val);
  NextToken;
 end else
 if TokenType=tk_Variable then begin
  if Variable.Kind<>_Integer then Error('integer expected');
  Result:=GetVariable(Variable);
  NextToken;
 end else
 if TokenType=tk_Parameter then begin
  if Parameter.Kind<>_Integer then Error('integer expected');
  Result:=SWFGetVariable(Parameter.realName);
  NextToken;
 end else
 if TokenType=tk_Symbol then begin
  Error('PushInteger symbol : '+Symbol.ClassName);
 end else Error('PushInteger : '+Token);
end;

function PushInteger1:string;
var
 op:TToken;
begin
 Result:=PushInteger2;
 while TokenType in [tk_Mul,tkDiv,tkMod] do begin
  op:=TokenType;
  NextToken;
  Result:=Result+PushInteger2;
  if op=tk_Mul then Result:=Result+acMultiply else
  if op=tkDiv  then Result:=Result+acDivide+acIntegralPart else
                    Result:=Result+acModulo;
 end;
end;

function PushInteger:string;
var
 op:TToken;
begin
 Result:=PushInteger1;
 while TokenType in [tk_Add,tk_Sub] do begin
  op:=TokenType;
  NextToken;
  Result:=Result+PushInteger1;
  if op=tk_Add then Result:=Result+acAdd else Result:=Result+acSubstract;
 end;
end;

// todo: boolean expression
function PushBoolean:string;
begin
 if SkipToken(tkTrue) then Result:=SWFPushBoolean(True) else
 if SkipToken(tkFalse) then Result:=SWFPushBoolean(False) else
 error('Unknow boolean');
end;

procedure GetInstance(var Instance:TInstance);
var
 target:TVariable;
begin
 target:=DropVariable;
 VarInstance(target,Instance);
end;

function GetSymbol(List:TSymbol):TSymbol;
begin
 while List<>nil do begin
  if List.name=Token then begin
   NextToken;
   Result:=List;
   exit;
  end;
  List:=List.NextSymbol;
 end;
// Error('unknow symbol (GetSymbol)');
 Result:=nil;
end;

function InheritedSymbol(AClass:TClass):TSymbol;
var
 base:TClass;
begin
 base:=AClass._inherite;
 Result:=GetSymbol(base._symbols);
 while Result=nil do begin
  base:=base._inherite;
  if base=nil then Error('unknow inherited symbol');
  Result:=GetSymbol(base._symbols);
 end;
end;

function ClassSymbol(AClass:TClass):TSymbol;
begin
 Result:=GetSymbol(AClass._symbols);
 if Result=nil then Result:=InheritedSymbol(AClass);
end;


function PushInstance:string;
var
 i:TInstance;
 s:TSymbol;
begin
 GetInstance(i);
 while SkipToken(tk_Dot) do begin
  if not (i.Kind is TClass) then Error('Class expected');
  s:=ClassSymbol(i.kind as TClass);
  if s is TVariable then begin
   i.code:=i.code+i.getter+SWFPushString(s.realName);
   i.kind:=TVariable(s).Kind;
   i.getter:=acGetMember;
   i.setter:=acSetMember;
  end else
   Error(s.className);
 end;
 Result:=i.code+i.getter;
end;

//----------------------------------------------------------------------------//

function PushKind(Kind:TSymbol):string;
begin
 if Kind=_String then Result:=PushString else
 if Kind=_Integer then Result:=PushInteger else
 if Kind=_Boolean then Result:=PushBoolean else
 if Kind is TClass then Result:=PushInstance else
 Error('unknown param type '+Kind.ClassName+' '+Kind.Name);
end;

function PushParams(Param:TParameter):string;
begin
 Result:='';
 if Param<>nil then begin
  if Param.NextParam<>nil then begin
   Result:=PushParams(Param.NextParam);
   DropToken(tk_Comma);
  end;
  Result:=PushKind(Param.Kind)+Result;
 end;
end;

function CallConstructor(Create:TMethod):string;
var
 parent:string;
begin
 Result:='';
 if create.alias<>'' then begin
 // call a parent method to create the new instance
 // Parent.create('instance',...)
  DropToken(tk_LParen);
 // nil parent is _root !
  if SkipToken(tkNil) then
   parent:=SWFGetVariable('_root')
  else
  if SkipToken(tkSelf) then
   parent:=SWFGetVariable('this')
  else
   parent:=PushInstance;
  if SkipToken(tk_Comma) then begin
   Result:=PushParams(create.params);
  end else begin
   if create.params<>nil then Error('parameter expected');
  end;
  DropToken(tk_RParen);
  Result:=SWFOptimize(
           Result
          +#$96#$01#$00#$03 // PushNull //SWFPushString('??')
          +SWFPushInteger(create.count)
          +parent
          +SWFCallMethod(create.alias)
          );
 end else begin
 // instance=new Class(...)
  if SkipToken(tk_LParen) then begin
   Result:=PushParams(create.params);
   DropToken(tk_RParen);
  end else begin
   if create.params<>nil then Error('parameter expected');
  end;
  Result:=SWFOptimize(
           Result
          +SWFPushInteger(create.count)
          +SWFNewObject(TClass(create.Kind).realName)
          );
 end;
end;

function CallFunction(method:TMethod):string;
begin
 Result:='';
 if SkipToken(tk_LParen) then begin
  Result:=PushParams(method.params);
  DropToken(tk_RParen);
 end;
 Result:=SWFOptimize(
          Result
         +SWFPushInteger(method.count)
         +SWFCallFunction(method.realName)
         );
end;

function ConstructClass(aclass:TClass):string;
var
 parent:string; // TVariable;
 base  :TClass;
 create:TMethod;
begin
// if instance.Kind<>aclass then Error('class mismatch');
 NextToken;
 DropToken(tk_Dot);
 base:=aclass;
 create:=base._constructor;
 while create=nil do begin
  base:=base._inherite;
  if base=nil then error('Constructor not found');
  create:=base._constructor;
 end;
 DropIdent(create.name);
 if (base is TUserClass) then begin
  if (create.code='') then Error('undefined constructor');
  Result:=CallFunction(create);
 end else begin
  Result:=CallConstructor(create);
 end;
end;

// todo: a lot of things !
function AssignStatement(Kind:TSymbol):string;
begin
// DropToken(tk_Assign);
 if Kind is TClass then begin
  if (TokenType=tk_Class) then
   Result:=ConstructClass(TClass(Symbol))
  else
   Error('Assign class')
 end else
 if Kind is TPrototype then begin
  if TokenType<>tk_Method then Error('Method expected');
  if TMethod(Symbol).Owner=nil then Error('Object method expected');
  Result:=SWFGetVariable('this')
         +SWFGetMember(TMethod(Symbol).realName);
  NextToken;
 end else
 if Kind=_String then begin
  Result:=PushString;
 end else
 if Kind=_Integer then begin
  Result:=PushInteger; 
 end else
  Error('Assign '+Kind.className+' '+Kind.realName);
end;

function SetProperty(const instance:string; prop:TProperty):string;
begin
 DropToken(tk_Assign);
 Result:=SWFOptimize(
         instance
        +SWFPushString(prop.realName)
        +PushKind(prop.Kind)
        +acSetMember
        );
end;

function CallMethod(const instance:string; method:TMethod):string;
begin
 Result:='';
 if SkipToken(tk_LParen) then begin
  Result:=PushParams(method.params);
  DropToken(tk_RParen);
 end;
 Result:=SWFOptimize(
          Result
         +SWFPushInteger(method.count)
         +instance
         +SWFCallMethod(method.realName)
         +acPop
         );
end;

function InstanceSuffix(var instance:TInstance):string;
var
 suffix:TSymbol;
 base:TClass;
 code:string;
begin
 if SkipToken(tk_Dot) then begin
  if not (instance.kind is TClass) then Error('Class expected');
  //Suffix:=InheritedSymbol(TClass(instance.Kind));

  base:=TClass(instance.Kind);
  repeat
   if base=nil then Error('unknow member');
   suffix:=GetSymbol(base._symbols);
   base:=base._inherite;
  until suffix<>nil;
  
  if suffix is TProperty then Result:=SetProperty(instance.code+instance.getter,TProperty(suffix)) else
  if suffix is TMethod then Result:=CallMethod(instance.code+instance.getter,TMethod(suffix)) else
  if suffix is TVariable then begin
   instance.code:=instance.code
                 +instance.getter
                 +SWFPushString(suffix.realName);
   instance.getter:=acGetMember;
   instance.setter:=acSetMember;
   instance.kind:=TVariable(Suffix).Kind;
   Result:=InstanceSuffix(instance);
  end else
  Error('suffix '+suffix.ClassName);
 end else begin
  DropToken(tk_Assign);
  Result:=SWFOptimize(
           instance.code
          +AssignStatement(instance.kind)
          +instance.setter
          );
 end;
end;


function VariableSuffix:string;
var
 instance:TInstance;
begin
 GetInstance(instance);
 Result:=InstanceSuffix(instance);
end;

function PropertySuffix:string;
var
 instance:TInstance;
begin
 //GetInstance(instance);
 instance.code:=SWFGetVariable('this')
               +SWFPushString(TProperty(Symbol).realName);
 instance.kind:=TProperty(Symbol).Kind;
 instance.getter:=acGetMember;
 instance.setter:=acSetMember;
 NextToken;              
 Result:=InstanceSuffix(instance);
end;

function Statement:string; forward;

// for var:=a to b do/downto statement;
function ForStatement:string;
var
 v:TVariable;
 init:string;
 test:string;
 code:string;
 temp:string;
begin
 NextToken;
 v:=DropVariable;
 if v.Kind<>_Integer then Error('ordinal expected');
 DropToken(tk_Assign);
 init:=SWFPushString(v.realName)
      +PushInteger
      +acSetVariable;
 if SkipToken(tkTo) then begin
  init:=init+PushInteger;
  test:=acDuplicate
       +SWFGetVariable(v.realName)
       +acLessThan;
  code:=SWFPushString(v.realName)
       +acDuplicate
       +acGetVariable
       +acIncrement
       +acSetVariable;
 end else begin
  DropToken(tkDownto);
  init:=init+PushInteger;
  test:=acDuplicate
       +SWFGetVariable(v.realName)
       +acLessThan;
  code:=SWFPushString(v.realName)
       +acDuplicate
       +acGetVariable
       +acDecrement
       +acSetVariable;
 end;
 DropToken(tkDo);
 code:=Statement+SWFOptimize(code);
 code:=SWFOptimize(test)+BranchIfEq(Length(code)+5 { Branch(-Length-(Code) } )+code;
 Result:=SWFOptimize(init)+code+Branch(-Length(Code)-5)+acPop;
end;

function CallThisMethod:string;
var
 m:TMethod;
begin
 m:=Symbol as TMethod;
 NextToken;
 Result:=CallMethod(SWFGetVariable('this'),m)
end;

function NextCase(Kind:TSymbol):string;
var
 s1,s2:string;
     l:integer;
begin
 if SkipToken(tkEnd) then begin
  Result:='';
 end else
 if SkipToken(tkElse) then begin
  Result:=Statement;
  SkipToken(tk_SemiColon);
  DropToken(tkEnd);
 end else
 begin
  Result:=acDuplicate+PushKind(Kind)+acEqual+acLogicalNot;
  DropToken(tk_Colon);
  s1:=Statement;
  DropToken(tk_SemiColon);
  s2:=NextCase(Kind);
  l:=length(s1);
  if s2<>'' then inc(l,5);
  Result:=Result+BranchIfEq(l)+s1;
  if s2<>'' then Result:=Result+Branch(Length(s2))+s2;
 end;
end;

// the case statement accept any kind of expression
// so it's time to uses TExpression :)
function CaseStatement:string;
var
 e:TExpression;
 s:string;
begin
 NextToken; // case
 e:=Expression;
 DropToken(tkOf);
 Result:=e.code+NextCase(e.Kind)+acPop;
 e.Free;
end;

// statement -or- begin statement1; statement2; end;
function Statement:string;
begin
 Result:='';
 case TokenType of
  tkBegin: begin
   NextToken;
   SkipToken(tk_SemiColon);
   while not SkipToken(tkEnd) do begin
    Result:=Result+Statement;
    if TokenType<>tkEnd then DropToken(tk_SemiColon) else SkipToken(tk_SemiColon);
   end;
  end;
  tk_Variable : Result:=VariableSuffix;
  tk_Property : Result:=PropertySuffix;
  tk_Method   : Result:=CallThisMethod;
  tkFor       : Result:=ForStatement;
  tkCase      : Result:=CaseStatement;
  tk_Symbol   : Error('unexpected symbol '+Symbol.ClassName+' '+Symbol.realName);
  else Error('Unexpected token (statement)');
 end;
end;

procedure DropParams(Param:TParameter);
begin
 if Param.NextParam=nil then begin
 // publish the parameters
  Param.NextSymbol:=Symbols;
  Symbols:=Param;
 end else begin
  DropParams(Param.NextParam);
 end;
 DropIdent(Param.name);
 DropToken(tk_Colon);
 DropIdent(Param.Kind.name);
end;

function MethodCall(AClass:TClass; AMethod:TMethod):string;
begin
 if (AMethod.Kind is TClass) and (TClass(AMethod.Kind)._constructor=AMethod) then begin
 end else begin
 end;
end;

function IsFlashClass(AClass:TClass):boolean;
begin
 if not (AClass is TUserClass) then
  Result:=True
 else begin
  if AClass._inherite=nil then
   Result:=False
  else
   Result:=IsFlashClass(AClass._inherite);
 end;
end;

function IsConstructor(Symbol:TSymbol):boolean;
begin
 Result:=(Symbol is TMethod)
      and(TMethod(Symbol).Kind is TClass)
      and(TClass(TMethod(Symbol).Kind)._constructor=Symbol);
end;

function DefineConstructor:string;
var
 cl:TClass;
 sy:TSymbol;
 s :string;
 build:boolean;
 flash:boolean;
 lastSym :TSymbol;
 p:TParameter;
 k:TSymbol;
 scope:TScope;
 parms:TScope;
begin
 NextToken;
 cl:=GetClass;
 if not (cl is TUserClass) then Error('not a user defined class');
 DropToken(tk_Dot);
 if cl._constructor=nil then Error('unknow constructor');
 DropIdent(cl._constructor.name);

 Scope.Symbol:=cl;
 Scope.Next:=Scopes;
 Scopes:=@Scope;

 if cl._constructor.params<>nil then begin
  DropToken(tk_LParen);
  DropParams(cl._constructor.params);
  DropToken(tk_RParen);
 end;
 DropToken(tk_SemiColon);
 cl._constructor.realName:=cl.realName+'$'+cl._constructor.realName;
 s:='';
 build:=False;
 flash:=IsFlashClass(cl);

 if SkipToken(tkVar) then begin
  repeat
   s:=s+DeclareVar(cl._constructor,cl._constructor.Symbols);
   DropToken(tk_SemiColon);
  until TokenType<>tk_Ident;
  parms.Symbol:=cl._constructor;
  parms.Next:=@Scope;
  Scopes:=@Parms;
 end;

 DropToken(tkBegin);

 // for a Flash Class we need to imediatly call the inherited constructor !
 if flash then begin
  DropToken(tkInherited);
  sy:=InheritedSymbol(cl);
  if not IsConstructor(sy) then Error('Flash constructor need to be called first !');
  s:=s+SWFPushString('this')
    +CallConstructor(TMethod(sy))
    +acSetVariable;
  build:=True;
  if TokenType=tkEnd then SkipToken(tk_SemiColon) else DropToken(tk_SemiColon);
 end;

 if cl is TUserClass then begin
  s:=s+TUserClass(cl).init;
 end;

 while not SkipToken(tkEnd) do begin
  if SkipToken(tkInherited) then begin
   sy:=InheritedSymbol(cl);
   if sy is TMethod then begin
    s:=s+MethodCall(cl,TMethod(sy));
   end else
    Error(sy.realName);
  end else
   s:=s+Statement;
  if TokenType=tkEnd then SkipToken(tk_SemiColon) else DropToken(tk_SemiColon);
 end;

 cl._constructor.code:=s
                      +SWFGetVariable('this')
                      +acReturn;

 DropToken(tk_SemiColon);

 s:=cl._constructor.realName+#0
   +SWFshort(cl._constructor.count);
 p:=cl._constructor.params;
 while p<>nil do begin
  s:=s+p.realName+#0;
  p:=p.NextParam;
 end;

 s:=s+SWFshort(length(cl._constructor.code));

 Result:=acDeclareFunction
        +SWFshort(Length(s))
        +s
        +cl._constructor.code;

 Scopes:=Scope.Next;
end;

function DefineMethod:string;
var
 cl:TClass;
 mt:TMethod;
 sy:TSymbol;
 s :string;
 lastSym :TSymbol;
 p:TParameter;
 k:TSymbol;
 scope:TScope;
begin
 cl:=GetClass;
 if not (cl is TUserClass) then Error('not a user defined class');
 DropToken(tk_Dot);

 sy:=GetSymbol(cl._symbols);
 if not (sy is TMethod) then Error('Method expected');
 mt:=TMethod(sy);

 Scope.Symbol:=cl;
 Scope.Next:=Scopes;
 Scopes:=@Scope;

 if mt.params<>nil then begin
  DropToken(tk_LParen);
  DropParams(mt.params);
  DropToken(tk_RParen);
 end else begin
  if SkipToken(tk_LParen) then DropToken(tk_RParen);
 end;
 DropToken(tk_SemiColon);
// mt.realName:=cl.realName+'$'+mt.realName;
 s:='';
 DropToken(tkBegin);

 while not SkipToken(tkEnd) do begin
  if SkipToken(tkInherited) then begin
   sy:=InheritedSymbol(cl);
   if sy is TMethod then begin
    s:=s+MethodCall(cl,TMethod(sy));
   end else
    Error(sy.realName);
  end else
   s:=s+Statement;
  if TokenType=tkEnd then SkipToken(tk_SemiColon) else DropToken(tk_SemiColon);
 end;

 mt.code:=s+acReturn;

 DropToken(tk_SemiColon);

 s:=cl.realName+'$'+mt.realName+#0
   +SWFshort(mt.count);
 p:=mt.params;
 while p<>nil do begin
  s:=s+p.realName+#0;
  p:=p.NextParam;
 end;

 s:=s+SWFshort(length(mt.code));

 Result:=acDeclareFunction
        +SWFshort(Length(s))
        +s
        +mt.code;

 Scopes:=Scope.Next;
end;

procedure CheckClass(AClass:TUserClass);
var
 s:TSymbol;
 m:TMethod absolute s;
begin
 s:=AClass._symbols;
 while s<>nil do begin
  if s is TMethod then begin
   if m.code='' then Error(AClass.realName+'.'+m.realName+' not defined');
  end;
  s:=s.NextSymbol;
 end;
end;

procedure CheckClasses;
var
 s:TSymbol;
begin
 s:=Symbols;
 while s<>nil do begin
  if s is TUserClass then CheckClass(TUserClass(s));
  s:=s.NextSymbol;
 end;
end;

procedure Compile;
var
 name:string;
 code:string;
    f:file;
    v:TVariable;
begin
 DropToken(tkProgram);
 name:=SrcToken+'.swf';
 GetIdent;
 DropToken(tk_SemiColon);
 code:='';
 while not SkipToken(tkBegin) do begin
  case TokenType of
   tkVar : begin
    NextToken;
    repeat
     code:=code+DeclareVar(nil,Symbols);
     DropToken(tk_SemiColon);
    until TokenType<>tk_Ident;
   end;
   tkType : begin
    NextToken;
    repeat DeclareType until TokenType<>tk_Ident;
   end;
   tkConstructor : code:=code+DefineConstructor;
   tkProcedure   : begin
    NextToken;
    if TokenType=tk_Class then code:=code+DefineMethod else error('static procedure');
   end;
   else Error('Unexpected token (compile)');
  end;
 end;

 CheckClasses;

 while not SkipToken(tkEnd) do begin
  code:=code+Statement;
  if TokenType<>tkEnd then DropToken(tk_SemiColon) else SkipToken(tk_SemiColon);
 end;
 if TokenType<>tk_Dot then Error('Expected .');

// todo: SWF GZCompression
 code:=SWFAttributes(0)
      +SWFBackground((Background shr 16) and $FF,(Background shr 8) and $FF,Background and $FF)
      +SWFDoAction(code+acEndAction)
      +SWFShowFrame // needed by FlashPlayer.exe to show the first frame
      +SWFEndTag;
 code:=SWFHeader(8,Length(code),FrameWidth,FrameHeight,FrameRate,1)+code;

 AssignFile(f,name);
 Rewrite(f,1);
 BlockWrite(f,code[1],Length(code));
 CloseFile(f);

{$IFDEF SHELL}
 ShellExecute(0,'open',pchar('"'+ExtractFilePath(ParamStr(0))+name+'"'),nil,nil,SW_SHOW);
{$ENDIF}
end;

//----------------------------------------------------------------------------//
function AddSymbol(const Name:string):TSymbol;
begin
 Result:=TSymbol.Create;
 Result.name:=Name;
 Result.NextSymbol:=Symbols;
 Symbols:=Result;
end;

begin
// init symbols
 Symbols :=nil;
 Scopes  :=nil;
 _Root   :=TVariable.Create;
 _Root.realName:='_root';
 _String :=AddSymbol('STRING');
 _Integer:=AddSymbol('INTEGER');
 _Boolean:=AddSymbol('BOOLEAN');
 _Object :=AddSymbol('TOBJECT');

 FrameWidth :=800;
 FrameHeight:=600;
 FrameRate  :=32;
 Background :=$FFFFFF;

// AssignFile(Source,ParamStr(1));
 AssignFile(Source,'Calc.pas');
 Reset(Source);

 Src  :='';
 Line :=1;
 Index:=0;
 ReadChar;
 NextToken;

 Dictionary.Items:=nil;
 Dictionary.Length :=0;
 Dictionary.Count  :=0;

 Compile;

 CloseFile(Source);

 WriteLn('OK');
 ReadLn;
end.
